#!/usr/bin/perl
# lcmake           [vmake_options] targets
#
# @(#)lcmake 2002-02-28
#
#
#    ========== licence begin  GPL
#    Copyright (C) 2001 SAP AG
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License
#    as published by the Free Software Foundation; either version 2
#    of the License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#    ========== licence end
#


use imake;
use Env;


$VMAKE_VARIANT=$ENV{VMAKE_DEFAULT_VARIANT};

$VMAKE_VARIANT="Release" unless ($VMAKE_VARIANT);
# default is not sync 
$sync = -1;
@NEWARGV=();
$makecall ="imf";
undef $found_config;	
undef $found_number;
$DSP2VMAKE=0;
$need_help=0;

while ($_ = $ARGV[0], /^-/) {
      shift @ARGV;
      last if /^--$/;
      
      if(/^-config=(.*)$/) 
	  {
         $found_config = $1 ; 
		 next; 
	  }
	  
	  if(/^-noconfig$/) 
	  {
          $found_config = "none" ; 
          next; 
	  }

	  if(/^-number=(.*)$/) 
	  {
		local $number = $1;
		$ENV{LATEST_CHANGE_LIST}=$1;
		$ENV{LATEST_CHANGE}=$ENV{LATEST_CHANGE_LIST};	
		$found_number = 1;
	    next;
	  }
		
	  if(/^-dsp2vmake$/) 
	  {
		 $DSP2VMAKE=1;
		 next;
	  }
	
	  if (/^-[h\?]$/)
	  {
	  	$need_help=1;
	  }
	  
	# add all not matched options 
      push @NEWARGV, $_;
	  next;
}
unless ($need_help)
{
	if ($ENV{APOMAKE})
	{
		# ckeck for default or modified Configuration and changelists
		if ( $found_config )
		{
			$VMAKE_VARIANT=$found_config;
		}
		
		if ($DSP2VMAKE)
		{
			die "Error: Option -dsp2vmake on remote machines not allowed !\n" if ($ENV{USER} =~ /\(remuser\)/);
			print ("Creating vmake descriptions ...\n");
			if ( $^O =~ /mswin/i)
			{
				system ("python $ENV{TOOL}\\bin\\dsp2vmake.py")== 0
				or die "Error while executing dsp2vmake.py\n" ;
			}
			else
			{
				system ("python $ENV{TOOL}/bin/dsp2vmake.py")== 0
				or die "Error while executing dsp2vmake.py\n" ;
			}
		}
		if ( $found_config eq "none" )
		{
			push @NEWARGV, @ARGV;
		}
		else
		{
			while ($_ = $ARGV[0]) {
				shift @ARGV;
				if (/^(.*)(\.[^.]*)$/)
				{
					$target=$1."+$VMAKE_VARIANT".$2;
				}
				else
				{
					$target=$_."+$VMAKE_VARIANT";
				}
				push @NEWARGV, $target;
			}
		}
		unless ($found_number)
		{
			if ($ENV{RELSTAT} =~ /^PROD$/i)
			{
				if ( -f "$ENV{OWN}/syncinfo.dat")
				{
					open(SYNCINFO, "< $ENV{OWN}/syncinfo.dat") || die "Couldn't open $ENV{OWN}/syncinfo.dat for reading";
					$syncnumber = <SYNCINFO>;
					if ( $syncnumber =~ /<maxchangenr>(.*)<\/maxchangenr>/)
					{
						$ENV{LATEST_CHANGE_LIST}= $1;
					}
					close (SYNCINFO);
					print ("Current changelist is $ENV{LATEST_CHANGE_LIST}\n");
				}
				elsif (-f "$ENV{OWN}/changelist.log")
				{
					open(CHLST, "<$OWN/changelist.log");
					local $changelist=<CHLST>;
					chomp $changelist;
					$ENV{LATEST_CHANGE_LIST} = $changelist;
					close CHLST;
					print ("Current changelist is $ENV{LATEST_CHANGE_LIST}\n");
				}
				elsif (-f "$ENV{OWN}/CHANGELIST")
				{
					open(CHLST, "<$OWN/CHANGELIST");
					$ENV{LATEST_CHANGE_LIST}=<CHLST>;
					close CHLST;
					print ("Current changelist is $ENV{LATEST_CHANGE_LIST}\n");
				}
				elsif ( $ENV{LATEST_CHANGE} )
				{
					$ENV{LATEST_CHANGE_LIST}=$ENV{LATEST_CHANGE};
				}
				else
				{
					print ("Waring: no changlist found \n     set LATEST_CHANGE_LIST to 111\n");
					$ENV{LATEST_CHANGE_LIST}="111";
				}
			}
			else
			{
				$ENV{LATEST_CHANGE_LIST}="000000";
			}
			
			$ENV{LATEST_CHANGE} = $ENV{LATEST_CHANGE_LIST};
		}
	}
	else
	{	
		push @NEWARGV, @ARGV;
		if ( $found_config )
		{
			if ( $found_config =~ /^fast$/i)
			{	$makecall="imf";}
			elsif ( $found_config =~ /^quick$/i)
			{	$makecall="imq";}
			elsif ( $found_config =~ /^slow$/i)
			{	$makecall="ims";}					
			else
			{
				die "wrong syntax for -config=fast|quick|slow\n";
			}
		}
	}
}
else
{
	 print <<End;
USAGE: lcmake  [-dsp2vmake] [-config=<conifguation>] [-number=<changelist>]

    -dsp2vmake    
              call dsp2vmake before make 
              (sources in OWN/sys/src directory necessary)
              
    -number=<changelist>
              set <changlist> for make
          
    -config=<configuration>
              set configuration 
              default configuration is set by $VMAKE_DEFAULT_VARIANT
End
   
	if ($ENV{APOMAKE})
	{
		print ("              (Release, Debug, ReleaseSim, DebugSim)\n\n")
	}
	else
	{
		print ("              (fast, quick, slow)\n\n")
	}
}

$ENV{VMAKE_CURRENT_VARIANT}=$VMAKE_VARIANT;

$rc = &{$makecall}(@NEWARGV);
die $@ if $@;
caller() ? $rc : exit $rc ;