#!/usr/bin/perl
# pcmktest
#
# @(#)pcmktstpkg
#
# Generate car archive for the given intrerfacetest
#
# Burkhard Diesing
#
#
#    ========== licence begin LGPL
#    Copyright (C) 2002 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#

package pcmktest;
use Env;
use PCTest;
sub AddFilesFromParfile;
sub CreateStd;

$USAGE ="USAGE: pcmktstpkg <arcivename> <sourcedir> <paramfile>\n";
if (@ARGV < 3 ) {
  print <DATA>;
  exit;
}

my ($ARCHIVE, $SOURCEDIR, $PARFILE) = @ARGV;
$pref=PCTest::GetPrefix($SOURCEDIR);
die "Sourcelayer not found." if ($pref eq "");

my ( $TEST_ROOT ) = PCTest::GetOWN;

$TEST_ROOT="$TEST_ROOT/test";

chdir $TEST_ROOT;

my ( $CMD_CREATECAR ) = "SAPCAR -cvf ./tr_$ARCHIVE.sar";
my ( $CMD_ADDCAR )    = "SAPCAR -avf ./tr_$ARCHIVE.sar";

 CreateStd;
 AddFilesFromParfile;

sub CreateStd
{
    system ("$CMD_CREATECAR ./pc/bin/$ARCHIVE*\n");
chdir $TEST_ROOT;
    system ("$CMD_ADDCAR $PARFILE\n");
    system ("$CMD_ADDCAR ./pc/incl/*.h\n");
    system ("$CMD_ADDCAR ./pc/incl/*.c\n");
    system ("$CMD_ADDCAR ./pc/lib/cpct.lib\n");
}


sub AddFilesFromParfile
{
    open (PARF, $PARFILE) or die "No paramfile '$PARFILE' found.";
    while (<PARF>) {
#       ignore comments
        s/\/\/.*|\#.*//g;
        if (/$SOURCEDIR\/(\w+)/) {
            system ("$CMD_ADDCAR ./pc/$SOURCEDIR/$1.*\n");
            if ( -f "./pc/old/$pref.$1.cpo" ) {
                system ("$CMD_ADDCAR ./pc/old/$pref.$1.cpo\n");
            }
        }
    }

    close (PARF);
}
